/*******************************************************************************
Main Class File:  <LLSequence.java>
File:             <LLSequence.java>

Author:           <Shan-Huen Huang>

Completion Date:  <06/07/2004>

Compiler:        <JDK 1.4.2>
Platform:         <Windows 2000>
*******************************************************************************/

public class LLSequence {

    public DoubleNode first;

    public DoubleNode current;

    public int sum;

    public LLSequence() {

    first=null;

    current=null;

    sum=0;

    } // Constructor

    private boolean isEmpty(){

     return first==null;

    } // isEmpty()

    public int size() {

    	return sum;

    } // size()

    public Object getCurrent() throws NoCurrentException{

		if (isEmpty()){

		throw new NoCurrentException("There are no nodes.");

		}	else {

		 return current.data;

		} // else

    } // getCurrent()

    public void addAfter(Object data) {

      DoubleNode newLink=new DoubleNode(data);

		  if(isEmpty()) {

			first=newLink;

			newLink.prior=newLink;

			newLink.next=newLink;

			sum++;

		  }  else  {

			newLink.next=current.next;

			current.next.prior=newLink;

		    newLink.prior=current;

		    current.next=newLink;

		    sum++;

		  } // else

       current=newLink;

   } // affAfter()

    public void addBefore(Object data) {

		DoubleNode newLink=new DoubleNode(data);

		  if(isEmpty()) {

			first=newLink;

			newLink.prior=newLink;

			newLink.next=newLink;

		    sum++;

		  }  else  {

		   newLink.prior=current.prior;

		   current.prior.next=newLink;

		   newLink.next=current;

		   current.prior=newLink;

		   sum++;

		  } // else

   		current=newLink;

    } // addBefore()

    public void advance() throws NoCurrentException{

		if(isEmpty()) {

			throw new NoCurrentException("There are no nodes.");

		} else {

			current=current.next;

		} // else

    } // advance()

    public void advance(int times) throws NoCurrentException{

		if(isEmpty()) {

			throw new NoCurrentException("There are no nodes.");

		} 	else {

			for(int i=0;i<times;i++) {

				current=current.next;

			} // for

		} // else

    } // advance()

    public void back() throws NoCurrentException{

		  if(isEmpty()) {

		  	throw new NoCurrentException("There are no nodes.");

		  }  else {

		 	current=current.prior;

		  } // else

    } // back()

    public void back(int times) throws NoCurrentException{

		if(isEmpty()) {

			throw new NoCurrentException("There are no nodes.");

		} else {

			for(int i=0;i<times;i++) {

				current=current.prior;

			} // for

		} // else

   } // back()

    public boolean lookup(Object item) {

      DoubleNode temp=new DoubleNode();

      if(isEmpty())

         return false;

      temp=first;

	  for(int i=0;i<sum;i++) {

			  if((temp.data).equals(item)) {

				   current=temp;

				   return true;

			  } // if

			  temp=temp.next;

	   } // for

      return false;

   } // lookup()

    public Object removeCurrent() throws NoCurrentException{

		if(isEmpty()) {

			throw new NoCurrentException("There are no nodes.");

		} else if(sum==1) {

			current=null;

			sum--;

			return null;

		} 	else	{

			current.prior.next=current.next;

			current.next.prior=current.prior;

			current=current.next;

			sum--;

			return current.data;

		} // else

     } // removeCurrent()

} // LLSequence