/*
 * Test.java
 *
 * HashTable{
 */

import java.awt.*;

import java.awt.event.*;

import javax.swing.*;

import java.util.*;

import java.text.*;


public class Test extends JFrame implements ActionListener{

	JTextArea output;
	JButton insert, lookup, delete, print, status, exit;
	HashTable table;
	JPanel north, south;
	JScrollPane jsp;

	int initSize;
	double alpha = 0.8;
	long randomSeed = 96;
	Random r;

	public static void main(String args[]) {

		Test test = new Test();
		test.setVisible(true);

	} // main

	public Test(){

		Container contentPane = getContentPane();

		setTitle("Hash Table Test");
		setSize(600, 600);
		setLocation(250, 200);
		contentPane.setLayout(new BorderLayout());

		output = new JTextArea();
		output.setEditable(false);

		jsp = new JScrollPane(output);
		jsp.setBorder(BorderFactory.createTitledBorder("Output"));


		insert = new JButton("Insert");
		insert.addActionListener(this);

		lookup = new JButton("LookUp");
		lookup.addActionListener(this);

		delete = new JButton("Delete");
		delete.addActionListener(this);

		print = new JButton("Print");
		print.addActionListener(this);

		exit = new JButton("Exit");
		exit.addActionListener(this);

		status = new JButton("Status");
		status.addActionListener(this);

		south = new JPanel(new FlowLayout());
		south.add(insert);
		south.add(lookup);
		south.add(delete);
		south.add(print);
		south.add(status);
		south.add(exit);

		contentPane.add(jsp, BorderLayout.CENTER);
		contentPane.add(south, BorderLayout.SOUTH);

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		String size = JOptionPane.showInputDialog(null, "пJHashTableljpG ", "ljp", JOptionPane.QUESTION_MESSAGE );
		initSize = Integer.parseInt(size);
		table = new HashTable(initSize, alpha);

		r = new Random(randomSeed);

		}//TowersOfHanoi()

	public void actionPerformed(ActionEvent e) {

			if(e.getSource() instanceof JButton) {

					JButton clicked = (JButton) e.getSource();

					if(clicked == insert) {

						Integer i = new Integer(r.nextInt());
						table.insert(i);
						output.append("Insert\t"+i.toString() + "\n");

					} else if(clicked == lookup){

						 String item = JOptionPane.showInputDialog(null, "пJjMG ", "jM", JOptionPane.QUESTION_MESSAGE );

						 if(table.lookup(new Integer(item)) != null) {

							 output.append(item + "\tis found.\n");

						}else{

							output.append(item + "\tis not existed in this HashTable.\n");

						}// else

					} else if(clicked == delete) {

						String item = JOptionPane.showInputDialog(null, "пJRG ", "R", JOptionPane.QUESTION_MESSAGE );

						if(table.delete(new Integer(item)) != null) {

							output.append(item + "\t is deleted.\n");

						} else {

							output.append(item + "\t is not contained in this HashTable.\n");

						}// else

					} else if(clicked == print) {

						String allItem = table.dump();
						output.append("\nAll items in the HashTable are : \n" + allItem + "\n");

					} else if(clicked == status){

						String status = table.displayStats();
						output.append("\n" + status);

					} else {

						System.exit(1);

					} // else if

			} // if

	}//action()

}//Test

