/*
 * BinarySearchTree.java
 *
 * ΨӾާ@Binary Search Tree
 */

import java.lang.*;

public class BinarySearchTree{

	private Node root; //make a new node as root

	public BinarySearchTree(){

		root=null;

	}//Constructor

	// bTreeM
	public entry lookup(entry item) {

		return lookup(root, item);

	} // lookup()

	private static entry lookup(Node T, entry k) {

		if (T == null) return null;

		if (T.key.compareTo(k)==0) return T.key;

		if (T.key.compareTo(k) > 0) {
			// k < this node's item; 
			return lookup(T.left, k);
		} // if
		else {
			// k > this node's item; k
			return lookup(T.right, k);
		} // else

	} // entrylookup()

	// NNode[JTree
	public void insert(entry item) throws DuplicateException {

		if (root == null) {

			root = new Node(item, null, null);

		}//If not found

		else insert(root, item);

	} // insert()

	private static void insert(Node T, entry k) throws DuplicateException {

		// precondition: T != null
		if (T.key.compareTo(k) == 0)

			throw new DuplicateException();

		if (T.key.compareTo(k) > 0) {

			if (T.left == null)

				T.left = new Node(k, null, null);

			else insert(T.left, k);

			}//end of if

		else {

			if (T.right == null) T.right = new Node(k, null, null);

			else insert(T.right, k);

		}//end of else

	} // insert()

	// NTreeNode
	public void delete(entry item) {

		root = delete(root, item);

	} // delete()

	private static Node delete(Node T, entry k)  {

		if (T == null) return null;

		if (T.key.compareTo(k)==0) {

		   if (T.left == null && T.right == null)

		   		return null;

		   else if

		   		(T.left == null) return T.right;//If T has only one child

		   else if

		   		(T.right == null) return T.left;

		   else{

			   Node tmp = smallestNode(T.right);

			   T.key = tmp.key;

			   T.right = delete(T.right, tmp.key);

			   return T;

			} // else

		} // if

		else if (T.key.compareTo(k) > 0) {

			T.left = delete(T.left, k);

			return T;

		} // elseif

		else {

			T.right = delete(T.right, k);

			return T;

		} // else

	}//end of delete

	// bTreeKEY̤pNode
	private static Node smallestNode(Node begin){

		if(begin.left == null){

			return begin;

		} else {

			return smallestNode(begin.left);

		} // else

	}//end of smallestNode

	// NY@ӽd򤺪NodeeLX
	public void printRange(entry begin, entry end){

	   printRange(root,begin,end);

	} // printRange()

	private static void printRange(Node T,entry begin,entry end){

		if(T != null){

			if(T.key.compareTo(begin)==0 && T.key.compareTo(end)==0){

				T.print();

			} // if

			if(T.key.compareTo(begin)>=0 && T.key.compareTo(end)<=0){

				if (!((T.key).compareTo(begin)<0 || (T.key).compareTo(end)>0)) {

								printRange(T.left,begin,end);
									T.print();
										printRange(T.right,begin,end);

				}// if

			}// if

			if(T.key.compareTo(begin)>0 && T.key.compareTo(end)>0)

				printL(T.left,begin,end);

			if(T.key.compareTo(begin)<0 && T.key.compareTo(end)<0)

				printL(T.right,begin,end);

		 }//end if

	}//end of private printRange

	private static void printL(Node T,entry begin,entry end){

		if(T != null){
				//if T.key  begin  end,  printRange()
			if(T.key.compareTo(begin)>=0 && T.key.compareTo(end)<=0)

				printRange(T,begin,end);

				else if(T.key.compareTo(begin)>0 && T.key.compareTo(end)>0)

						printL(T.left,begin,end);

					 else

							printL(T.right,begin,end);

		}//end of if

	}//end of printL

	// NTreeҦNodeCLX
	public void printAll(){

		 printAll(root);

	}//end of printAll

	private static void printAll(Node temp){ // Print by order

		if(temp != null){

				 printAll(temp.left);
					temp.print();
				 printAll(temp.right);

		} // if

	} // printAll()

	// Ǧ^TreeRoot
	public Node getRoot(){

		return root;

	}//getRoot

}//BinarySearchTree
