/*
 * VRPCanvas.java
 *
 * ΨӵeXMSTe
 */

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.awt.geom.*;

class VRPCanvas extends Canvas {

	final static int WIDTH = 600;
	final static int HEIGHT = 600;

	boolean draw = false;
	int numOfNodes = 10;
	double distance;
	point nodes[];
	point selectedNodes[];
	Vector liAdj = new Vector();

	String currline;
	String fileName;

	public VRPCanvas() {}

	public VRPCanvas(String fileName)
	{

		this.fileName = fileName;

	} // Constructor

	public void paint(Graphics g)
	{

		Graphics2D g2d = (Graphics2D)g;

		nodes = new point[numOfNodes];
		selectedNodes = new point[numOfNodes];

		for(int i = 0; i < selectedNodes.length; i ++) {

			selectedNodes[i] = new point(0.0, 0.0);

		} // for

		g2d.setColor(Color.GREEN);

		g2d.clearRect(0, 0, getWidth(), getHeight());

		try{

			randomData();

		} catch(Exception e) {

				System.out.println("About Others\t" + e);

			} // catch


		for(int i=0; i<nodes.length; i++) {

			if( i == 0) {

				g2d.setPaint(Color.yellow);
				g2d.fill(new Ellipse2D.Double(nodes[i].getX(), nodes[i].getY(),10, 10));

			} 	else {

				g2d.setPaint(Color.red);
				g2d.fill(new Rectangle2D.Double(nodes[i].getX(), nodes[i].getY(),7, 7));

			} // else

		} // for

		if(draw){

			mst();


				for(int k = 0; k < liAdj.size(); k++) {

					g2d.setPaint(Color.pink);

					point start = ((line)(liAdj.get(k))).getP1();

					point end = ((line)(liAdj.get(k))).getP2();

					g2d.draw(new Line2D.Double(start.getX(), start.getY(), end.getX(), end.getY()));

				} // for

			g2d.setPaint(Color.black);
			g2d.setFont(new Font("Distance", Font.BOLD, 14));
			g2d.drawString("Total Distance = " + distance, 20, 580);

		}// if

	}//paint

	// method mst()
	public void mst(){

		nodes[0].setSelected();

		selectedNodes[0] = nodes[0];

		double shortest;

		distance = 0;

		int index = -1;

		line li;

		line shortLine = null;

		for(int j = 1; j < selectedNodes.length; j++) {

			shortest = Double.MAX_VALUE;

		  for(int k = 0; k < j; k++){

			for(int i = 0; i < nodes.length; i++) {

				if(!(nodes[i].getSelected())) {

					li = new line(selectedNodes[k], nodes[i]);

					if(shortest > li.getDist()) {

						shortest = li.getDist();

						index = i;

						shortLine = li;

					} // if

				} // if

			} // for

		} // for

		distance = distance + shortest;

		nodes[index].setSelected();

		selectedNodes[j] = nodes[index];

		liAdj.addElement(shortLine);

		nodes[index].printPoint();

	  } // for

	} // mst()

	public void randomData() {

		double x = WIDTH/2;

		double y = HEIGHT/2;

		point p = new point(x, y);

		nodes[0] = p;

		for(int i = 1; i < nodes.length; i++) {

			x = Math.random()*WIDTH;
			y = Math.random()*(HEIGHT-30);

			p = new point(x, y);

			nodes[i] = p;

		} // for

	} // randomData()

}//VRPCanvas